rtsetparams(44100, 2)

print_off()
srand()

load("./RTcmix/libs/libWAVETABLE.so")
load("./RTcmix/libs/libPANECHO.so")

bus_config("WAVETABLE", "aux 0 out")
bus_config("PANECHO", "aux 0 in", "out 0-1")


ampenv = maketable("line", 1000, 0,0, 1,1, 2,0)
amp = 2000

basepch = 7.09
basemove = { -2, -3, 2, 3 }
pch1s = { 0.00, 0.02, 0.03, 0.05, 0.07, 0.10, 0.12 }
lpch1s = len(pch1s)
pch2s = { 0.00, 0.02, 0.04, 0.05, 0.07, 0.09, 0.12 }
lpch2s = len(pch2s)
pdev = 0.0019

wave = maketable("wave", 1000, 1, random(), random(), random()*0.5, random()*0.2)

jump = irand(7, 21)
for (st = 0; st < 3000; st += jump) {
	if (random() < 0.5) {
		pset = pch1s
		lpset = lpch1s
	} else {
		pset = pch2s
		lpset = lpch2s
	}

	if (random() < 0.5)
		wave = maketable("wave", 1000, 1, random(), random(), random()*0.5, random()*0.2)

	if (random() < 0.3) {
		mbase = midipch(basepch)
		mbase += basemove[trand(0, len(basemove))]
		basepch = pchmidi(mbase)
		if (basepch > 8.04) basepch -= 1.00
		if (basepch < 7.03) basepch += 1.00
	}

	nnotes = trunc(trand(1, 4))
	for (i = 0; i < nnotes; i += 1) {
		pch = basepch + pset[trand(0, lpset)]
		dur = irand(10, 25)
		WAVETABLE(st, dur, amp*ampenv, pch, 0, wave)
		WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0, wave)
		WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0, wave)
		WAVETABLE(st, dur, amp*ampenv, pch+irand(0, pdev), 0, wave)
	}

	jump = irand(7, 21)
}

PANECHO(0, 0, st, 1, 0.14, 0.34, 0.78, 7, 0)
